
QGIS Application - Bug report #8334

"Save selection as" is slow from large PostGIS table

2013-07-21 09:10 PM - Nyall Dawson

Status: Closed

Priority: Normal

Assignee:

Category: Vectors

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 17122

Description

Steps to reproduce:

1. Load a large PostGIS table (containing millions of points)

2. Select a single feature

3. Right click layer, choose "Save Selection As" 

4. Choose filename and options

QGIS takes a very long time to export this single point. It seems to take even longer than it does to load the entire PostGIS table into

QGIS.

Expected result:

Since only a single point feature is selected, the selection would be saved almost instantaneously.

Associated revisions

Revision f0d31b03 - 2015-11-05 11:22 AM - Nyall Dawson

Use a FilterFids request for vector file writer rather than fetching

all features and then testing the feature id when saving selected

features

For providers such as Postgres this is orders of magnitude faster.

Eg, saving 6 selected features from a 800k PostGIS table now

takes < 1 second as opposed to ~33 seconds

Fix #8334

Revision 57381f49 - 2015-11-18 11:00 AM - Nyall Dawson

Use a FilterFids request for vector file writer rather than fetching

all features and then testing the feature id when saving selected

features

For providers such as Postgres this is orders of magnitude faster.

Eg, saving 6 selected features from a 800k PostGIS table now

takes < 1 second as opposed to ~33 seconds

Fix #8334
(cherry-picked from f0d31b03a9bbc1d43e1b51ccd4acf64cf2616a63)

History

#1 - 2015-11-05 02:59 AM - Nyall Dawson

- Status changed from Open to Closed

Fixed in changeset commit:"f0d31b03a9bbc1d43e1b51ccd4acf64cf2616a63".
